using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using DartScoreboard.Data;


namespace DartScoreboard.GUI.Controls
{
    /// <summary>
    /// Interaction logic for DartMarks.xaml
    /// </summary>

    public partial class DartMarks : System.Windows.Controls.UserControl
    {
        private int _marks = 0;

        public DartMarks()
        {
            InitializeComponent();
            _marks = 0;
        }

        public void Initialize()
        {
            

            //line1GS.Color = Color.FromRgb(0, 0, 0);
            //line2GS.Color = Color.FromRgb(0, 0, 0);
            //line3GS.Color = Color.FromRgb(0, 0, 0);

            UnMarkThirdScore();
            UnMarkSecondScore();
            UnMarkFirstScore();

            _marks = 0;
            
        }

        public List<int> MarkDarts(int numberHit)
        {
            List<int> dartMarks = new List<int>();

            if (_marks < 3)
            {
                switch (_marks)
                {
                    case 0:
                        switch (numberHit)
                        {
                            case 1:
                                MarkFirstScore();
                                dartMarks.Add(1);
                                break;
                            case 2:
                                MarkFirstScore();
                                MarkSecondScore();
                                dartMarks.Add(2);
                                dartMarks.Add(1);
                                break;
                            case 3:
                                MarkFirstScore();
                                MarkSecondScore();
                                MarkThirdScore();
                                dartMarks.Add(3);
                                dartMarks.Add(2);
                                dartMarks.Add(1);
                                break;
                        }
                        break;

                    case 1:
                        if (numberHit > 1)
                        {
                            MarkSecondScore();
                            MarkThirdScore();
                            dartMarks.Add(3);
                            dartMarks.Add(2);
                        }
                        else
                        {
                            MarkSecondScore();
                            dartMarks.Add(2);
                        }
                        break;

                    case 2:
                        MarkThirdScore();
                        dartMarks.Add(3);
                        break;
                }
            }

            return dartMarks;
        }

        public void UnMarkDarts(List<int> dartMarks)
        {
            if (dartMarks.Count <= 0) return;

            foreach (int mark in dartMarks)
            {

                switch (mark)
                {
                    case 1:
                        UnMarkFirstScore();
                        break;
                    case 2:
                        UnMarkSecondScore();
                        break;
                    case 3:
                        UnMarkThirdScore();
                        break;
                }
            }
        }

        private void MarkFirstScore()
        {
            Storyboard animation = (Storyboard)FindResource("line1Animation");

            animation.Begin(this);
            _marks = 1;
        }

        private void MarkSecondScore()
        {
            Storyboard animation = (Storyboard)FindResource("line2Animation");

            animation.Begin(this);
            _marks = 2;
        }

        private void MarkThirdScore()
        {
            Storyboard animation = (Storyboard)FindResource("line3Animation");

            animation.Begin(this);
            _marks = 3;
        }

        private void UnMarkFirstScore()
        {
            Storyboard animation = (Storyboard)FindResource("line1AnimationUndo");

            animation.Begin(this);
            _marks = 0;
        }

        private void UnMarkSecondScore()
        {
            Storyboard animation = (Storyboard)FindResource("line2AnimationUndo");

            animation.Begin(this);
            _marks = 1;
        }

        private void UnMarkThirdScore()
        {
            Storyboard animation = (Storyboard)FindResource("line3AnimationUndo");

            animation.Begin(this);
            _marks = 2;
        }


    }
}