Imports System
Imports System.Windows 'uielement
Imports System.Windows.Media 'visual operations
Imports System.Windows.Media.Animation 'animation effect stuff

Namespace DartScoreboardVB.Animations
    Public Class TimeTracker
#Region "Private Memebers"

        Private _lastTime As DateTime
        Private _deltaTime As Double
        Private _timerInterval As Double = -1
#End Region

#Region "Properties"

        Public Property TimerInterval() As Double
            Get
                Return _timerInterval
            End Get
            Set(ByVal Value As Double)
                _timerInterval = Value
            End Set
        End Property

        Public ReadOnly Property ElapsedTime() As DateTime
            Get
                Return _lastTime
            End Get
        End Property

        Public ReadOnly Property DeltaSeconds() As Double
            Get
                Return _deltaTime
            End Get
        End Property

#End Region

#Region "Events"
        Public Event TimerFired As EventHandler
#End Region

#Region "Constructors"
        Public Sub New()
            _lastTime = DateTime.Now
        End Sub
#End Region

        Public Function Update() As Double
            Dim currentTime As DateTime = DateTime.Now

            'get the difference in time
            Dim diffTime As TimeSpan = currentTime - _lastTime
            _deltaTime = diffTime.TotalSeconds

            'does the user want a callback on regular intervals?
            If _timerInterval > 0.0 Then
                '                 
                '                 'compute the intervals for this and previous update
                '                 Integer currInterval = CType((currentTime / TimeSpan.FromSeconds(_timerInterval)), Integer)
                '                 Integer prevInterval = CType((_lastTime / TimeSpan.FromSeconds(_timerInterval)), Integer)
                '  
                '                 'has the interval changed since last update?
                '                 if (currInterval <> prevInterval)
                '                 {
                '                     'fire interval event
                '                     'note that this will only be called once per frame at most
                '                     ' so if they interval is too small, you wont get 2+ fires per frame
                '                     TimerFired(this, Nothing)
                '                 
                '                 }
                '  */

                If currentTime <> _lastTime Then
                    RaiseEvent TimerFired(Me, Nothing)
                End If
            End If

            'cycle old time
            _lastTime = currentTime

            Return _deltaTime
        End Function
    End Class
End Namespace

