Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Media.Imaging
Imports System.Windows.Shapes
Imports DartScoreboardVB.Data


Namespace DartScoreboardVB.GUI.Controls
    '/ <summary>
    '/ Interaction logic for DartMarks.xaml
    '/ </summary>

    Partial Public Class DartMarks
        Inherits System.Windows.Controls.UserControl
        Private _marks As Integer = 0

        Public Sub New()
            InitializeComponent()
            _marks = 0
        End Sub

        Public Sub Initialize()


            'line1GS.Color = Color.FromRgb(0, 0, 0);
            'line2GS.Color = Color.FromRgb(0, 0, 0);
            'line3GS.Color = Color.FromRgb(0, 0, 0);

            UnMarkThirdScore()
            UnMarkSecondScore()
            UnMarkFirstScore()

            _marks = 0

        End Sub

        Public Function MarkDarts(ByVal numberHit As Integer) As List(Of Integer)
            Dim dartMarks As List(Of Integer) = New List(Of Integer)()

            If _marks < 3 Then
                Select Case _marks
                    Case 0
                        Select Case numberHit
                            Case 1
                                MarkFirstScore()
                                dartMarks.Add(1)
                            Case 2
                                MarkFirstScore()
                                MarkSecondScore()
                                dartMarks.Add(2)
                                dartMarks.Add(1)
                            Case 3
                                MarkFirstScore()
                                MarkSecondScore()
                                MarkThirdScore()
                                dartMarks.Add(3)
                                dartMarks.Add(2)
                                dartMarks.Add(1)
                        End Select
                    Case 1
                        If numberHit > 1 Then
                            MarkSecondScore()
                            MarkThirdScore()
                            dartMarks.Add(3)
                            dartMarks.Add(2)
                        Else
                            MarkSecondScore()
                            dartMarks.Add(2)
                        End If
                    Case 2
                        MarkThirdScore()
                        dartMarks.Add(3)
                End Select
            End If

            Return dartMarks
        End Function

        Public Sub UnMarkDarts(ByVal dartMarks As List(Of Integer))
            If dartMarks.Count <= 0 Then
                Return
            End If

            Dim mark As Integer
            For Each mark In dartMarks

                Select Case mark
                    Case 1
                        UnMarkFirstScore()
                        Exit For
                    Case 2
                        UnMarkSecondScore()
                        Exit For
                    Case 3
                        UnMarkThirdScore()
                        Exit For
                End Select
            Next
        End Sub

        Private Sub MarkFirstScore()
            Dim animation As Storyboard = CType(FindResource("line1Animation"), Storyboard)

            animation.Begin(Me)
            _marks = 1
        End Sub

        Private Sub MarkSecondScore()
            Dim animation As Storyboard = CType(FindResource("line2Animation"), Storyboard)

            animation.Begin(Me)
            _marks = 2
        End Sub

        Private Sub MarkThirdScore()
            Dim animation As Storyboard = CType(FindResource("line3Animation"), Storyboard)

            animation.Begin(Me)
            _marks = 3
        End Sub

        Private Sub UnMarkFirstScore()
            Dim animation As Storyboard = CType(FindResource("line1AnimationUndo"), Storyboard)

            animation.Begin(Me)
            _marks = 0
        End Sub

        Private Sub UnMarkSecondScore()
            Dim animation As Storyboard = CType(FindResource("line2AnimationUndo"), Storyboard)

            animation.Begin(Me)
            _marks = 1
        End Sub

        Private Sub UnMarkThirdScore()
            Dim animation As Storyboard = CType(FindResource("line3AnimationUndo"), Storyboard)

            animation.Begin(Me)
            _marks = 2
        End Sub


    End Class
End Namespace
