Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports DartScoreboardVB.GUI.Controls

Namespace DartScoreboardVB.GUI.Forms
    '/ <summary>
    '/ Interaction logic for Start.xaml
    '/ </summary>

    Partial Public Class Start
        Inherits System.Windows.Controls.UserControl

        Public Delegate Sub GameStartedDelegate(ByVal players As List(Of DartDataSet.PlayerRow))
        Public GameStarted As GameStartedDelegate

        Private _numberOfPlayersList As List(Of String) = New List(Of String)()
        Private _playerIndex As Integer = 0

        Private _inGame As Boolean = False

        Public Property InGame() As Boolean
            Get
                Return _inGame
            End Get
            Set(ByVal Value As Boolean)
                _inGame = Value
            End Set
        End Property

        Public Sub New()
            InitializeComponent()
            Me.Cursor = Cursors.None
            _numberOfPlayersList.Add("1 PLAYER")
            _numberOfPlayersList.Add("2 PLAYERS")
            _numberOfPlayersList.Add("3 PLAYERS")
            _numberOfPlayersList.Add("4 PLAYERS")

            player1.LoadPlayers()
        End Sub


        Private Sub OnPlayerCountChange(ByVal direction As Integer)
            If _playerIndex + direction = _numberOfPlayersList.Count Then
                _playerIndex = 0
            ElseIf _playerIndex + direction < 0 Then
                _playerIndex = _numberOfPlayersList.Count - 1
            Else
                _playerIndex += direction
            End If

            tbPlayerCountSelect.Text = _numberOfPlayersList(_playerIndex)

            Dim numberOfPlayers As Integer = _playerIndex + 1


            If playerPanel.Children.Count < numberOfPlayers Then
                While playerPanel.Children.Count < numberOfPlayers
                    playerPanel.Children.Add(New PlayerChooser())
                End While
            ElseIf playerPanel.Children.Count > numberOfPlayers Then
                While playerPanel.Children.Count > numberOfPlayers
                    playerPanel.Children.RemoveAt(playerPanel.Children.Count - 1)
                End While
            End If

        End Sub

        Private Sub StartGame()
            Dim playersRows As List(Of DartDataSet.PlayerRow) = New List(Of DartDataSet.PlayerRow)()

            Dim element As UIElement
            For Each element In playerPanel.Children
                If TypeOf element Is PlayerChooser Then
                    playersRows.Add((CType(element, PlayerChooser)).PlayerRow)
                End If
            Next

            If Not GameStarted Is Nothing Then
                GameStarted(playersRows)
            End If
        End Sub

        Private Sub OnStart(ByVal sender As Object, ByVal e As RoutedEventArgs)
            StartGame()
        End Sub

        Private Sub OnNumPlayersNext(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
            OnPlayerCountChange(1)
        End Sub

        Private Sub OnNumPlayersPrevious(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
            OnPlayerCountChange(-1)
        End Sub
    End Class
End Namespace

'----------------------------------------------------------------
' Converted from C# to VB .NET using CSharpToVBConverter(1.2).
' Developed by: Kamal Patel (http://www.KamalPatel.net) 
'----------------------------------------------------------------
