Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Shapes
Imports System.Windows.Media.Media3D
Imports System.Windows.Media.Animation

'Namespace DartScoreboardVB.GUI.Forms
'/// <summary>
'/// Interaction logic for Main.xaml
'/// </summary>

Partial Public Class Window1
    Inherits System.Windows.Window

    Enum Mode
        Start
        Scoreboard
    End Enum

    Private _mode As Mode

    Public Sub New()
        InitializeComponent()
        Me.Cursor = Cursors.None
        ucStart.GameStarted += OnGameStarted()
        ucScoreboard.GameFinished += ucScoreboard_GameFinished()
        ucScoreboard.GameReset += ucScoreboard_GameReset()
        _mode = Mode.Start
    End Sub

    Private Sub ucScoreboard_GameReset()
        _mode = Mode.Start
        ucStart.InGame = True
        ChangeView()
    End Sub

    Private Sub ucScoreboard_GameFinished()
        _mode = Mode.Start
        ucStart.InGame = False
        ChangeView()
    End Sub


        Public  Sub StartGame(ByVal playerRows As List<DartDataSet.PlayerRow>)
        _mode = Mode.Scoreboard
        ucScoreboard.StartGame(playerRows)
        ChangeView()
    End Sub


        Private  Sub OnGameStarted(ByVal playerRows As List<DartDataSet.PlayerRow>)
        StartGame(playerRows)
    End Sub


    Private Sub zoomOutStoryboardCompleted(ByVal sender As Object, ByVal args As EventArgs)
        If _mode = Mode.Scoreboard Then
            ucStart.Visibility = Visibility.Hidden
            ucScoreboard.Visibility = Visibility.Visible
        Else
            ucStart.Visibility = Visibility.Visible
            ucScoreboard.Visibility = Visibility.Hidden
        End If

        Dim s As Storyboard = CType(Me.Resources("ZoomInStoryboard"), Storyboard)
        s.Begin(Me)
    End Sub


    Private Sub zoomInStoryboardCompleted(ByVal sender As Object, ByVal e As EventArgs)
        scrollViewerBorder.Visibility = Visibility.Visible
    End Sub


    Private Sub ChangeView()

        Dim points As Point3DCollection = New Point3DCollection()

        Dim ratio As Double = myScrollViewer.ActualWidth / myScrollViewer.ActualHeight

        points.Add(New Point3D(5, -5 * ratio, 0))
        points.Add(New Point3D(5, 5 * ratio, 0))
        points.Add(New Point3D(-5, 5 * ratio, 0))

        points.Add(New Point3D(-5, 5 * ratio, 0))
        points.Add(New Point3D(-5, -5 * ratio, 0))
        points.Add(New Point3D(5, -5 * ratio, 0))

        points.Add(New Point3D(-5, 5 * ratio, 0))
        points.Add(New Point3D(-5, -5 * ratio, 0))
        points.Add(New Point3D(5, -5 * ratio, 0))

        points.Add(New Point3D(5, -5 * ratio, 0))
        points.Add(New Point3D(5, 5 * ratio, 0))
        points.Add(New Point3D(-5, 5 * ratio, 0))

        myGeomeTry.Positions = points
        myViewport3D.Width = 100
        myViewport3D.Height = 100 * ratio

        scrollViewerBorder.Visibility = Visibility.Hidden

        Dim s As Storyboard = CType(Me.Resources("ZoomOutStoryboard"), Storyboard)
        s.Begin(Me)

    End Sub

End Class
'End Namespace

